---
title: Range Slider
product: Form Library
description: Learn how to add and configure a two-thumb range slider in a SurveyJS form. It demonstrates how to define the slider's scale (min, max, and step values), set default selections, and enforce limits on the range length that users can select.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/dual-range-slider-input/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Range Slider (Vanilla JS)

A Range Slider displays a predefined scale with two draggable thumbs, allowing users to select a range of values. Users can also drag the entire selected range along the scale without changing the distance between the thumbs. This demo showcases the Range Slider question included out of the box in the SurveyJS Form Library.

## Create a Range Slider Question

To add a Range Slider question to your survey or form, define an object with the `type` property set to `"slider"` and add it to the [`elements`](/form-library/documentation/api-reference/page-model#elements) array. Within this object, set the [`sliderType`](/form-library/documentation/api-reference/questionslidermodel#sliderType) property to `"range"`, specify the question's [`title`](/form-library/documentation/api-reference/questionslidermodel#title), and assign a unique [`name`](/form-library/documentation/api-reference/questionslidermodel#name) to identify it. You can also provide a [`description`](/form-library/documentation/api-reference/questionslidermodel#description), which will appear below the title.

## Configure the Slider Scale

The slider scale defines the range of valid values and the interval between selectable points (snap points). The main scale settings include:

- [`min`](/form-library/documentation/api-reference/questionslidermodel#min): `number`         
The minimum value on the scale.

- [`max`](/form-library/documentation/api-reference/questionslidermodel#max): `number`         
The maximum value on the scale.

- [`step`](/form-library/documentation/api-reference/questionslidermodel#step): `number`         
The interval between snap points.

This example demonstrates both the default scale configuration&mdash;`min: 0, max: 100, step: 1`&mdash;and a customized one&mdash;`min: 100, max: 1000, step: 50`.

A Range Slider also displays labels that indicate specific values along the scale. For details on how to configure these labels, refer to the following demo:

[Configure Slider Scale Labels](/form-library/examples/customize-slider-scale-labels/ (linkStyle))

## Set a Default Slider Value

The default value sets the initial position of the slider thumbs and is saved in the survey results if the user doesn't change the selection. By default, this value is undefined, and the thumbs start at the beginning and the end of the scale. Use the [`defaultValue`](/form-library/documentation/api-reference/questionslidermodel#defaultValue) property to assign a static default, or the [`defaultValueExpression`](/form-library/documentation/api-reference/questionslidermodel#defaultValueExpression) property to calculate it dynamically.

In this demo, one of the Range Sliders has a default value of [20, 80], specified using the `defaultValue` property.

## Limit the Range Length

To prevent users from selecting a range that is too short or too long, use the [`minRangeLength`](/form-library/documentation/api-reference/questionslidermodel#minRangeLength) and [`maxRangeLength`](/form-library/documentation/api-reference/questionslidermodel#maxRangeLength) properties. These properties accept numeric values that define the minimum and maximum allowable range lengths.

In this demo, the bottom Range Slider restricts selection to a range no shorter than 20 and no longer than 60.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "slider",
      "sliderType": "range",
      "name": "default-configuration",
      "title": "Default configuration",
      "description": "Min = 0 | Max = 100 | Step = 1"
    },
    {
      "type": "slider",
      "sliderType": "range",
      "name": "change-min-max-step",
      "title": "Change min, max, and step",
      "description": "Min = 100 | Max = 1000 | Step = 50",
      "min": 100,
      "max": 1000,
      "step": 50,
      "labelCount": 4
    },
    {
      "type": "slider",
      "sliderType": "range",
      "name": "set-default-value",
      "title": "Set a default value",
      "description": "Default value = [20, 80]",
      "defaultValue": [ 20, 80 ]
    },
    {
      "type": "slider",
      "sliderType": "range",
      "name": "limit-range-length",
      "title": "Limit the range length",
      "description": "Min range length = 20 | Max range length = 60",
      "minRangeLength": 20,
      "maxRangeLength": 60
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/dual-range-slider-input/angular.md)
- [React](https://surveyjs.io/form-library/examples/dual-range-slider-input/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/dual-range-slider-input/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/dual-range-slider-input/jquery.md)


---
title: Range Slider
product: Form Library
description: Learn how to add and configure a two-thumb range slider in a SurveyJS form. It demonstrates how to define the slider's scale (min, max, and step values), set default selections, and enforce limits on the range length that users can select.
framework: React
source: https://surveyjs.io/form-library/examples/dual-range-slider-input/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Range Slider (React)

A Range Slider displays a predefined scale with two draggable thumbs, allowing users to select a range of values. Users can also drag the entire selected range along the scale without changing the distance between the thumbs. This demo showcases the Range Slider question included out of the box in the SurveyJS Form Library.

## Create a Range Slider Question

To add a Range Slider question to your survey or form, define an object with the `type` property set to `"slider"` and add it to the [`elements`](/form-library/documentation/api-reference/page-model#elements) array. Within this object, set the [`sliderType`](/form-library/documentation/api-reference/questionslidermodel#sliderType) property to `"range"`, specify the question's [`title`](/form-library/documentation/api-reference/questionslidermodel#title), and assign a unique [`name`](/form-library/documentation/api-reference/questionslidermodel#name) to identify it. You can also provide a [`description`](/form-library/documentation/api-reference/questionslidermodel#description), which will appear below the title.

## Configure the Slider Scale

The slider scale defines the range of valid values and the interval between selectable points (snap points). The main scale settings include:

- [`min`](/form-library/documentation/api-reference/questionslidermodel#min): `number`         
The minimum value on the scale.

- [`max`](/form-library/documentation/api-reference/questionslidermodel#max): `number`         
The maximum value on the scale.

- [`step`](/form-library/documentation/api-reference/questionslidermodel#step): `number`         
The interval between snap points.

This example demonstrates both the default scale configuration&mdash;`min: 0, max: 100, step: 1`&mdash;and a customized one&mdash;`min: 100, max: 1000, step: 50`.

A Range Slider also displays labels that indicate specific values along the scale. For details on how to configure these labels, refer to the following demo:

[Configure Slider Scale Labels](/form-library/examples/customize-slider-scale-labels/ (linkStyle))

## Set a Default Slider Value

The default value sets the initial position of the slider thumbs and is saved in the survey results if the user doesn't change the selection. By default, this value is undefined, and the thumbs start at the beginning and the end of the scale. Use the [`defaultValue`](/form-library/documentation/api-reference/questionslidermodel#defaultValue) property to assign a static default, or the [`defaultValueExpression`](/form-library/documentation/api-reference/questionslidermodel#defaultValueExpression) property to calculate it dynamically.

In this demo, one of the Range Sliders has a default value of [20, 80], specified using the `defaultValue` property.

## Limit the Range Length

To prevent users from selecting a range that is too short or too long, use the [`minRangeLength`](/form-library/documentation/api-reference/questionslidermodel#minRangeLength) and [`maxRangeLength`](/form-library/documentation/api-reference/questionslidermodel#maxRangeLength) properties. These properties accept numeric values that define the minimum and maximum allowable range lengths.

In this demo, the bottom Range Slider restricts selection to a range no shorter than 20 and no longer than 60.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "slider",
      "sliderType": "range",
      "name": "default-configuration",
      "title": "Default configuration",
      "description": "Min = 0 | Max = 100 | Step = 1"
    },
    {
      "type": "slider",
      "sliderType": "range",
      "name": "change-min-max-step",
      "title": "Change min, max, and step",
      "description": "Min = 100 | Max = 1000 | Step = 50",
      "min": 100,
      "max": 1000,
      "step": 50,
      "labelCount": 4
    },
    {
      "type": "slider",
      "sliderType": "range",
      "name": "set-default-value",
      "title": "Set a default value",
      "description": "Default value = [20, 80]",
      "defaultValue": [ 20, 80 ]
    },
    {
      "type": "slider",
      "sliderType": "range",
      "name": "limit-range-length",
      "title": "Limit the range length",
      "description": "Min range length = 20 | Max range length = 60",
      "minRangeLength": 20,
      "maxRangeLength": 60
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/dual-range-slider-input/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/dual-range-slider-input/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/dual-range-slider-input/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/dual-range-slider-input/vanillajs.md)


---
title: Range Slider
product: Form Library
description: Learn how to add and configure a two-thumb range slider in a SurveyJS form. It demonstrates how to define the slider's scale (min, max, and step values), set default selections, and enforce limits on the range length that users can select.
framework: Angular
source: https://surveyjs.io/form-library/examples/dual-range-slider-input/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Range Slider (Angular)

A Range Slider displays a predefined scale with two draggable thumbs, allowing users to select a range of values. Users can also drag the entire selected range along the scale without changing the distance between the thumbs. This demo showcases the Range Slider question included out of the box in the SurveyJS Form Library.

## Create a Range Slider Question

To add a Range Slider question to your survey or form, define an object with the `type` property set to `"slider"` and add it to the [`elements`](/form-library/documentation/api-reference/page-model#elements) array. Within this object, set the [`sliderType`](/form-library/documentation/api-reference/questionslidermodel#sliderType) property to `"range"`, specify the question's [`title`](/form-library/documentation/api-reference/questionslidermodel#title), and assign a unique [`name`](/form-library/documentation/api-reference/questionslidermodel#name) to identify it. You can also provide a [`description`](/form-library/documentation/api-reference/questionslidermodel#description), which will appear below the title.

## Configure the Slider Scale

The slider scale defines the range of valid values and the interval between selectable points (snap points). The main scale settings include:

- [`min`](/form-library/documentation/api-reference/questionslidermodel#min): `number`         
The minimum value on the scale.

- [`max`](/form-library/documentation/api-reference/questionslidermodel#max): `number`         
The maximum value on the scale.

- [`step`](/form-library/documentation/api-reference/questionslidermodel#step): `number`         
The interval between snap points.

This example demonstrates both the default scale configuration&mdash;`min: 0, max: 100, step: 1`&mdash;and a customized one&mdash;`min: 100, max: 1000, step: 50`.

A Range Slider also displays labels that indicate specific values along the scale. For details on how to configure these labels, refer to the following demo:

[Configure Slider Scale Labels](/form-library/examples/customize-slider-scale-labels/ (linkStyle))

## Set a Default Slider Value

The default value sets the initial position of the slider thumbs and is saved in the survey results if the user doesn't change the selection. By default, this value is undefined, and the thumbs start at the beginning and the end of the scale. Use the [`defaultValue`](/form-library/documentation/api-reference/questionslidermodel#defaultValue) property to assign a static default, or the [`defaultValueExpression`](/form-library/documentation/api-reference/questionslidermodel#defaultValueExpression) property to calculate it dynamically.

In this demo, one of the Range Sliders has a default value of [20, 80], specified using the `defaultValue` property.

## Limit the Range Length

To prevent users from selecting a range that is too short or too long, use the [`minRangeLength`](/form-library/documentation/api-reference/questionslidermodel#minRangeLength) and [`maxRangeLength`](/form-library/documentation/api-reference/questionslidermodel#maxRangeLength) properties. These properties accept numeric values that define the minimum and maximum allowable range lengths.

In this demo, the bottom Range Slider restricts selection to a range no shorter than 20 and no longer than 60.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "elements": [
    {
      "type": "slider",
      "sliderType": "range",
      "name": "default-configuration",
      "title": "Default configuration",
      "description": "Min = 0 | Max = 100 | Step = 1"
    },
    {
      "type": "slider",
      "sliderType": "range",
      "name": "change-min-max-step",
      "title": "Change min, max, and step",
      "description": "Min = 100 | Max = 1000 | Step = 50",
      "min": 100,
      "max": 1000,
      "step": 50,
      "labelCount": 4
    },
    {
      "type": "slider",
      "sliderType": "range",
      "name": "set-default-value",
      "title": "Set a default value",
      "description": "Default value = [20, 80]",
      "defaultValue": [ 20, 80 ]
    },
    {
      "type": "slider",
      "sliderType": "range",
      "name": "limit-range-length",
      "title": "Limit the range length",
      "description": "Min range length = 20 | Max range length = 60",
      "minRangeLength": 20,
      "maxRangeLength": 60
    }
  ]
};
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/dual-range-slider-input/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/dual-range-slider-input/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/dual-range-slider-input/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/dual-range-slider-input/vanillajs.md)
